<?php

namespace Controllers;

use Slim\Container;
use models\SettingsModel;
use Slim\Http\Request;


/**
 * Class SettingsController
 * @package Controllers
 */
class SettingsController extends ProtectedController
{

    /**
     * @var \models\ISettings
     */
    private $settingsModel;

    public function __construct(Container $container)
    {
        parent::__construct($container);

        $this->settingsModel = new SettingsModel($container);

    }

    /**
     * @param Request $request
     * @param $response
     * @param $args
     * @return mixed
     */
    public function getSettings(Request $request, $response, $args)
    {
        $data = [
            'success' => true,
            'data' => $this->settingsModel->getSettingsWithoutPassword()
        ];
        $response = $response->withJson($data);
        return $response;
    }


    public function setSettings(Request $request, $response, $args)
    {

        $data = $request->getParsedBody();

        if(isset($data['make_backup']) && $data['make_backup'] == 'true'){
            $this->settingsModel->makeBackup();
        }

	$this->container->logger->debug("SettingsController::setSettings()", $data);

        if($this->settingsModel->validate($data) && $this->settingsModel->update($data)){
            $data = [
                'success' => true,
                'data' => 'Settings successfully saved.'
            ];
            $response = $response->withJson($data);
        }

        return $response;
    }


}
