#!/bin/bash
set -ex

. buildscripts/build-scripts/travis
cd mission-portal

	# - sudo add-apt-repository ppa:ondrej/php -y
	# - sudo apt-get update
	# - sudo apt-get install -y php5.6 php5.6-cli php5.6-xdebug php5.6-xml php5.6-curl php5.6-mbstring php5.6-mcrypt php-pear php5.6-pgsql

	# sudo apt-get purge apache* postgresql*
	# sudo hostname localhost

	s3cmd get $DEB_PACKAGE cfe.deb
	sudo dpkg -i *.deb

	sudo cf-agent -B "$(ifconfig | grep -A1 Ethernet | sed '2!d;s/.*addr:\([0-9.]*\).*/\1/')"
	sudo cf-agent -Kfupdate.cf
	sudo cf-agent -K
	wget --no-check-certificate -qO- https://localhost/index.php/login/index | grep -q '<title>CFEngine Mission Portal - Log in</title>'

	# disable phar.readonly in php.ini
	for line in $(find /home/travis/ -name php.ini); do
        sed -ri 's/^(\s|;)phar.readonly = On/phar.readonly = Off/' "$line"
    done



	# patch cf-apache to point to the new repo
	# note that current work dir is repo root
	# - sudo sed -i "s./var/cfengine/httpd/htdocs.$(pwd)." /var/cfengine/httpd/conf/httpd.conf
	sudo cp -r /var/cfengine/httpd/htdocs/public/tmp ./public
	sudo cp -r /var/cfengine/httpd/htdocs/api .
	sudo cp -r /var/cfengine/httpd/htdocs/application/config/appsettings.php ./application/config/
	# - sudo /var/cfengine/httpd/bin/httpd -k restart

	# Install PHPUnit
	# - wget https://phar.phpunit.de/phpunit-5.7.phar
	# - chmod +x phpunit-5.7.phar
	# - sudo mv phpunit-5.7.phar /usr/local/bin/phpunit

	# stop cf-execd service to avoid bootstrapped agent appearing in the DB during tests execution
	sudo systemctl stop cf-execd
	sudo systemctl stop cf-hub

	composer update
	export S3_DIR
	cd tests
	  composer update
    sudo sh ./testData/customActions/environment.sh
    sudo chown -R travis:travis /home/travis/build/cfengine/mission-portal
    sudo mkdir -p /opt/cfengine/federation/cfapache/
    sudo chown -R cfapache:travis /opt/cfengine
    sudo chown -R cfapache:travis /home/travis/build/cfengine/mission-portal
    sudo -E $(which php)  ./vendor/phpunit/phpunit/phpunit --coverage-clover=coverage.xml

	# setup requirements to run selenium tests


	$(which php) ./vendor/phpunit/phpunit/phpunit --version

	which geckodriver || (wget https://github.com/mozilla/geckodriver/releases/download/v0.26.0/geckodriver-v0.26.0-linux64.tar.gz && tar xvf geckodriver-v0.26.0-linux64.tar.gz && sudo mv geckodriver /usr/local/bin)
	which geckodriver
	geckodriver -V

	# # which java || (sudo apt-get install default-jre)
	# ls -l /etc/alternatives/java
	# #java -version
	# #sudo apt-get install default-jre
	# until sudo apt-get update; do
	# 	echo 'RETRYING...'
	# 	sleep 12
	# done
	# sudo apt-get install oracle-java8-installer
	# #sudo update-java-alternatives --set java-1.7.0-openjdk-amd64
	# echo | sudo update-alternatives --config java
	# ls -l /etc/alternatives/java
	# java -version

	wget -O java.tar.gz 'http://buildcache.cfengine.com/build-tools/jre-8u151-linux-x64.tar.gz'
	sudo mkdir /opt/jdk
	sudo tar -zxvf java.tar.gz -C /opt/jdk
	javadir="$(echo /opt/jdk/*)"
	sudo update-alternatives --install /usr/bin/java java $javadir/bin/java 2000
	sudo update-alternatives --set java $javadir/bin/java
	echo | sudo update-alternatives --config java
	ls -l /etc/alternatives/java
	java -version

	wget http://selenium-release.storage.googleapis.com/3.4/selenium-server-standalone-3.4.0.jar

	#firefox -v
	#sudo apt-get update
	# sudo DEBIAN_FRONTEND=noninteractive DEBIAN_PRIORITY=critical apt-get -q -y -o "Dpkg::Options::=--force-confdef" -o "Dpkg::Options::=--force-confold" upgrade
	#sudo apt-get install firefox
	sudo rm -f /usr/local/bin/f*
	#which firefox
	wget "https://download.mozilla.org/?product=firefox-latest&os=linux64&lang=en-US" -O firefox.tar.bz2
	tar xvf firefox.tar.bz2
	sudo ln -s $PWD/firefox/firefox /usr/bin/firefox
	firefox -V

	#sudo apt-get install x11vnc # DEBUG

	# start background processes

	export DISPLAY=:1
	Xvfb $DISPLAY -screen 0 1920x1080x16 >xvfb.log 2>&1 &
	#x11vnc -safer -passwd "Aiqua0ph" -display $DISPLAY & # DEBUG
	java -jar selenium-server-standalone-3.4.0.jar >selenium.log 2>&1 &

	# wait for background processes to start
	sleep 10

	# start actual testing

	sudo -E $(which php) ./vendor/phpunit/phpunit/phpunit --configuration phpunit_selenium.xml

